﻿#include <vector>
#include <iostream>
#include<cmath>
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
using namespace std;
struct Input {
	vector<double> numbers;
	size_t bin_count{};

};

Input input_data()
{
	size_t number_count;
	cin >> number_count;
	Input in;
	in.numbers.resize(number_count);
	for (size_t i = 0; i < number_count; i++)
	{
		cin >> in.numbers[i];

	}

	cin >> in.bin_count;

	return in;
}

void find_minmax(const vector<double>& numbers, double& min, double& max) {
	min = numbers[0];
	max = numbers[0];
	for (double x : numbers)
	{
		if (x < min)
			min = x;
		else if (x > max)
			max = x;
	}
}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count) {
	double min, max;
	find_minmax(numbers, min, max);
	vector<size_t> bins(bin_count);
	double bin_size = (max - min) / bin_count;
	for (size_t i = 0; i < numbers.size(); i++)
	{
		bool found = false;
		for (size_t j = 0; (j < bin_count - 1) && !found; j++)
		{
			auto low = min + j * bin_size;
			auto high = min + (j + 1) * bin_size;
			if ((low <= numbers[i]) && (numbers[i] < high))
			{
				bins[j]++;
				found = true;
			}
		}
		if (!found)
		{
			bins[bin_count - 1]++;
		}
	}
	return bins;
}

void show_histogram_text(vector<size_t> bins, size_t bin_count) {
	double mxbins = bins[0];
	for (double x : bins)
	{
		if (x > mxbins)
			mxbins = x;
	}
	double k;
	if (mxbins > MAX_ASTERISK)
		k = MAX_ASTERISK / mxbins;
	else
		k = 1;
	for (size_t i = 0; i < bin_count; i++)
	{
		if (bins[i] < 10) {
			cout << "  ";
		}
		else if (bins[i] < 100) {
			cout << " ";
		}
		cout << bins[i] << "|";
		for (int j = 0; j < floor(bins[i] * k); j++)
		{
			cout << "*";
		}

		cout << endl;
	}
}

int main()
{
	Input in = input_data();
	vector <size_t> bins = make_histogram(in.numbers, in.bin_count);
	show_histogram_text(bins, in.bin_count);
}
